% GenerateEgretFigure - Generate the egret-pelican figure: a single figure with all detection results for egrets and pelicans.
%   The figure is located at "./pelican_egret_matching.eps".
%   The shape script is found at "result/egret/egret_template.eps" or "result/egret/template.png".  

Iname = {'pelican 2_big.jpg','pelican3.jpg',...
    'pelican4.jpg','pelican5.jpg','pelican6.jpg',...
    'pelican7.jpg','pelican8.jpg','pelican9.jpg',...
    'pelican10.jpg'};
Iname_pelican = Iname;
imScale = [0.25 0.4 0.4 0.4 ...
    0.22 0.36 0.5 0.4 0.3];

category = 'pelican';
overlay_pelican = cell(length(imScale),1);
j_detection = 1;
for i = 1:length(imScale)
    load(sprintf('result/%s/detectionResult%d_%s.mat',category,j_detection,Iname{i}),...
                'im','mask','S3Map','M2Map');
    overlay_pelican{i} = im + 400 * mask;
end

Iname = {'l1.jpg','l2.jpg','l3.jpg','l4.jpg','l5.jpg',...
    'l6.jpg','l7.jpg','l8.jpg','l9.jpg','l10.jpg',...
    'l11.jpg','l12.jpg','l13.jpg','l14.jpg','l15.jpg',...
    'l16.jpg','l17.jpg','l18.jpg','l19.jpg','l20.jpg',...
    'l21.jpg', 'l22.jpg','l23.jpg','l24.jpg','l25.jpg',...
    'l26.jpg','l27.jpg','l28.jpg','l29.jpg','l30.jpg',...
    'l4_dup.jpg', 'l12_dup.jpg', 'l12_dup2.jpg'};
Iname_egret = Iname;
imScale = [1.2 1.2 1 2 1,...
    1 1.2 0.9 0.9 1,...
    0.95 1 1.1 1 1,...
    1.1 0.8 1.2 1.2 0.9,...
    .55 .3,.3 .25 .3 ...
    .3 .4,.3 .35 .3,...
    1.15 1.1 1.2];
category = 'egret';
overlay_egret = cell(length(imScale),1);
j_detection = 1;
for i = 1:length(imScale)
    load(sprintf('result/%s/detectionResult%d_%s.mat',category,j_detection,Iname{i}),...
                'im','mask','S3Map','M2Map');
    overlay_egret{i} = im + 400 * mask;
end

%%
% selected_egret = setdiff(1:33,[6 7 9 11 13 16 19 20 21 23 24 25 27 28 29 30]);
selected_egret = 1:33; % select all of them
% selected_pelican = [7:9];
selected_pelican = 1:9; % select all of them

overlay = [overlay_egret(selected_egret);overlay_pelican(selected_pelican)];
Iname = [Iname_egret(selected_egret) Iname_pelican(selected_pelican)];

frames = cell(2*length(overlay),3);
% now interleve original image with overlay
for k = 1:length(overlay)
    if k <= length(selected_egret)
        im = imread(sprintf('image/egret/%s',Iname{k}));
    else
        im = imread(sprintf('image/pelican/%s',Iname{k}));
    end
    
    for c = 1:3
        frames{2*(k-1)+1,c} = im(:,:,c); % source image
        frames{2*(k-1)+2,c} = overlay{k}; % overlay
    end
end

addpath common
for c = 1:3
    channel{c} = displayImages(frames(:,c),10,200,200);
end
towrite = zeros(size(channel{1}),'uint8');
for c = 1:3
    towrite(:,:,c) = channel{c};
end
figure; imshow(towrite);
saveas(gcf,'pelican_egret_matching.eps','epsc');

