function allfiltered = applyfilterMultiScale(I, allfilter, nGaborOri)
% applyfilterMultiScale - Filter image by a bank of multiscale filters, with local normalization.  
% 
% I: input images
% allfilter: filter bank
%

localRadius = 1; % local normalization: Gabor response divided by local mean, pooled from a local neighborhood with radius proportional to filter size  
numFilter = length(allfilter);  % total number of filters
nGaborScale = numFilter / nGaborOri;

allfiltered = cell(numFilter,1);
for iScale = 1:nGaborScale % perform feature convolution per scale
    allfiltered((iScale-1)*nGaborOri+(1:nGaborOri)) = ...
        applyfilterfftsameLocalNorm(I, allfilter((iScale-1)*nGaborOri+(1:nGaborOri)), localRadius);
end



