% dumpNeg - Precompute Gabor response maps on background/negative images.

imageNames = dir('../image/neg/*.jpg');
n = length(imageNames);
load ../template_params GaborFilter nGaborOri
mkdir ../feature
mkdir ../feature/neg/
for i = 1:min(5,n)
    im = imread(sprintf('../image/neg/%s',imageNames(i).name));
    if size(im,3) == 3
        im = rgb2gray(im);
    end
    im = single(im);
    if size(im,1) * size(im,2) > 512 * 512
        im = imresize(im, 512/sqrt(size(im,1)*size(im,2)), 'nearest');
    end
    S1Map = applyfilterMultiScale({im},GaborFilter, nGaborOri);
    save(sprintf('../feature/neg/%s.mat',imageNames(i).name),'S1Map');
    clear S1Map
end

